<?php

date_default_timezone_set('Asia/Tokyo');

session_start();

require_once './functions.php';

$favicon    = FAVICON;
$title      = MAIN_TITLE;
$logTitle   = LOG_TITLE;
$logFile    = LOG_FILE;
// ページリンク表示非表示
$linkCss = $logFile == ''  ? 'none' : 'block';
$lines      = LINE_LIMIT;
$maxName    = NAME_LIMIT;
$maxComment = COMMENT_LIMIT;
$color0     = COLOR_0;
$color1     = COLOR_1;
$color2     = COLOR_2;
$color3     = COLOR_3;
$color4     = COLOR_4;
$separator  = SEPA;
$timeline   = TIME_LINE;
$btmtopCss  = $timeline == 'top'  ? 'bottom' : 'top';
$topbtmCss  = $timeline == 'top'  ? 'top' : 'bottom';

$name = $_POST['name'] ?? '';
// 「お名前」の前後の半角スペースを削除
$name = trim($name);


$token = filter_input(INPUT_POST, 'csrf_token');

if(!empty($_POST)){

  // トークンがない、もしくは一致しない場合、処理を中止
  if (!isset($_SESSION['csrf_token']) || $token !== $_SESSION['csrf_token']) {
    exit('不正なリクエスト');
  }
  unset($_SESSION['csrf_token']);

  $onebbs = $_POST;
  // MySQLのdatetime型に整形
  $date = date('Y-m-d H:i:s');
  bbsPost($onebbs);
}

// 総投稿件数を取得
$count = lineCount();
$allpage = ceil($count / $lines);
  if ($allpage < 2) {
    $linkCss = 'none';
  }

$result = getData(0, $lines);

// 「お名前」の配列リストを作成
if (!empty($result)) {
  foreach ($result as $a){
    $array[] = $a['name'];
  }
$val = array_unique($array);
$array = array_values($val);
}

if ($timeline != 'top') {
$result = array_reverse($result);
}
?>
<!DOCTYPE html>
<html>
<head>
<meta charset="utf-8">
<meta name="viewport" content="width=device-width">
<title><?php echo h($title); ?></title>
<link rel="icon" href="<?php echo $favicon; ?>">
<style>
body {
  color: black;
  background-color: white;
}
#title {
  font-size: xx-large;
  font-weight: bold;
  text-decoration: underline;
  text-align: center;
  margin-bottom: 0.8em;
}
form {
  margin-<?php echo $btmtopCss; ?>: 1em;
}
.line {
  color: <?php echo $color4; ?>;
  border-<?php echo $btmtopCss; ?>: 1px black solid;
  padding: 0.2em;
}
.lines {
  text-align: center;
  font-size: small;
}
.color0 {
  color: <?php echo $color0; ?>;
}
.color1 {
  color: <?php echo $color1; ?>;
}
.color2 {
  color: <?php echo $color2; ?>;
}
.color3 {
  color: <?php echo $color3; ?>;
}
#log {
  margin-<?php echo $topbtmCss; ?>: 0.3em;
  display: <?php echo $linkCss; ?>;
}
#log a {
  color: blue;
  font-style: italic;
  text-decoration: none;
}
#ver {
  text-align: right;
  font-size: small;
}
#ver a {
  color: gray;
  text-decoration: none;
}
</style>
</head>
<body>
<div id="title"><?php echo h($title); ?></div>

<?php if ($timeline == 'top'): ?>
<form method="post">
<input type="text" id="name" name="name" required maxlength="<?php echo $maxName; ?>" size="16" value="<?php echo h($name); ?>" placeholder="お名前（<?php echo $maxName; ?>文字まで）"><?php echo h($separator); ?><input type="text" id="comment" name="comment" required maxlength="<?php echo $maxComment; ?>" size="80" placeholder="コメント（<?php echo $maxComment; ?>文字まで）">
<input type="hidden" name="csrf_token" value="<?php echo h(setToken()); ?>">
<input type="submit" value="投稿">
</form>
<?php else: ?>
<div class="lines">
最大表示件数は、<?php echo $lines; ?>件です。
</div>
<div id="log">&gt;&gt; <a href="<?php echo $logFile; ?>?p=2"><?php echo $logTitle; ?></a></div>
<?php endif; ?>
    <?php foreach($result as $column): ?>
      <div class="line color<?php echo h(array_keys($array, $column['name'])[0]); ?>">
      <?php echo h($column['name']); ?><?php echo h($separator); ?><?php echo urlText($column['comment']); ?> (<?php echo h($column['date']); ?>)
      </div>
    <?php endforeach; ?>

<?php if ($timeline == 'top'): ?>
<div id="log">&gt;&gt; <a href="<?php echo $logFile; ?>?p=2"><?php echo $logTitle; ?></a></div>
<div class="lines">
最大表示件数は、<?php echo $lines; ?>件です。
</div>
<?php else: ?>
<form method="post">
<input type="text" id="name" name="name" required maxlength="<?php echo $maxName; ?>" size="16" value="<?php echo h($name); ?>" placeholder="お名前（<?php echo $maxName; ?>文字まで）"><?php echo h($separator); ?><input type="text" id="comment" name="comment" required maxlength="<?php echo $maxComment; ?>" size="80" placeholder="コメント（<?php echo $maxComment; ?>文字まで）">
<input type="hidden" name="csrf_token" value="<?php echo h(setToken()); ?>">
<input type="submit" value="投稿">
</form>
<?php endif; ?>

<div id="ver"><a href="https://www.wave440.com/onebbs/" target="_blank">Ver.2.0</a></div>
</body>
</html>
